/* Manipolazione e manutenzione di una coda */

#include <stdio.h>
#include <stdlib.h>

struct queueNode { /* struttura ricorsiva */
    char data;
    struct queueNode *nextPtr;
};

typedef struct queueNode QUEUENODE;
typedef QUEUENODE *QUEUENODEPTR;

/* protipi delle funzioni */
void printQueue(QUEUENODEPTR);
int isEmpty(QUEUENODEPTR);
char dequeue (QUEUENODEPTR *, QUEUENODEPTR *);
void enqueue(QUEUENODEPTR *, QUEUENODEPTR *, char);
void instructions(void);

main()
{

   QUEUENODEPTR headPtr = NULL, tailPtr = NULL;
   int choice;
   char item;

   instructions();
   printf("? ");
   scanf("%d", &choice);

   while (choice != 3) {

      switch(choice) {
        case 1:
	   printf("Inserisci un valore: ");
	   scanf("\n%c", &item);
	   enqueue(&headPtr, &tailPtr, item);
	   printQueue(headPtr);
	   break;
	case 2:
	   if (!isEmpty(headPtr)) {
	       item = dequeue(&headPtr, &tailPtr);
	       printf("%c Il valore  stato rimosso.\n", item);
	   }

	   printQueue(headPtr);
	   break;

        default:
	    printf("Digitazione errata.\n\n");
	    instructions();
	    break;
       }

       printf("? ");
       scanf("%d", &choice);
    }

    printf("Fine della procedura.\n");
    return 0;
}

void instructions(void)
{
   printf (" Digita:\n"
           "       1 per aggiungere un valore nella coda\n"
	   "       2 per rimuovere un valore dalla coda\n"
	   "       3 per uscire dalla procedura\n");
}

void enqueue(QUEUENODEPTR *headPtr, QUEUENODEPTR *tailPtr, char value)

{
    QUEUENODEPTR newPtr;

    newPtr = malloc(sizeof(QUEUENODE));

    if (newPtr != NULL) {
        newPtr->data = value;
	newPtr->nextPtr = NULL;
    if(isEmpty(*headPtr))
       *headPtr = newPtr;
    else
       (*tailPtr)->nextPtr = newPtr;

        *tailPtr = newPtr;
  }
  else
     printf("%c Non inserito.Memoria non disponibile.\n", value);
}

char dequeue(QUEUENODEPTR *headPtr, QUEUENODEPTR *tailPtr)
{
   char value;
   QUEUENODEPTR tempPtr;

   value = (*headPtr)->data;
   tempPtr = *headPtr;
   *headPtr = (*headPtr)->nextPtr;

   if(*headPtr == NULL)
      *tailPtr = NULL;

      free(tempPtr);
      return value;
}

int isEmpty(QUEUENODEPTR headPtr)
{
   return headPtr == NULL;
}

void printQueue(QUEUENODEPTR currentPtr)
{
   if (currentPtr == NULL)
      printf("La coda  vuota.\n\n");
   else {
       printf("La coda :\n");


      while (currentPtr != NULL) {
          printf("%c --> ", currentPtr->data);
	  currentPtr = currentPtr->nextPtr;
      }

      printf("NULL\n\n");
   }
}
