/* Manipolazione e manutenzione di una lista */
#include <stdio.h>
#include <stdlib.h>

struct listNode {  /*struttura ricorsiva */
    char data;
    struct listNode *nextPtr;
};

typedef struct listNode LISTNODE;
typedef LISTNODE *LISTNODEPTR;

void insert(LISTNODEPTR *, char);
char delete(LISTNODEPTR *, char);
int isEmpty(LISTNODEPTR);
void printList(LISTNODEPTR);
void instructions(void);

main()
{
  LISTNODEPTR startPtr = NULL;
  int choice;
  char item;

  instructions(); /* visualizza il menu */
  printf("Cosa vuoi fare? ");
  scanf("%c", &choice);

  while (choice != 3) {

    switch (choice) {
       case 1:
          printf("Digita un carattere: ");
	  scanf("\n%c", &item);
	  insert(&startPtr, item);
	  printList(startPtr);
	  break;
       case 2:
          if (!isEmpty(startPtr)) {
	     printf("Digita il carattere da eliminare: ");
	     scanf("\n%c", &item);

	     if (delete(&startPtr, item)) {
	         printf("%c Cancellato!\n", item);
		 printList(startPtr);
             }
	     else
	        printf("%c Non trovato!\n\n", item);
	  }
	  else
	      printf("Lista  vuota!\n\n");

	  break;
       default:
          printf("Digitazione errata\n\n");
	  instructions();
	  break;
   }

   printf(" ? ");
   scanf("%d", &choice);
 }

 printf("Fine della procedura\n");
 return 0;
 }

 /* Visualizza le istruzioni */
 void instructions(void)
 {
    printf("Digita:\n"
           " 1 per inserire un elemento nella lista.\n"
	   " 2 per eliminare un elemento dalla lista.\n"
	   " 3 per terminare.\n");
 }

 /* Inserisce ordinatamente un nuovo valore nella lista */
 void insert(LISTNODEPTR *sPtr, char value)

 {
     LISTNODEPTR newPtr, previousPtr, currentPtr;

     newPtr = malloc(sizeof(LISTNODE));

     if (newPtr != NULL) {  /* la memoria  disponibile? */
        newPtr->data = value;
	newPtr->nextPtr = NULL;

	previousPtr = NULL;
	currentPtr = *sPtr;

	while (currentPtr !=NULL && value > currentPtr->data) {
	    previousPtr = currentPtr;         /* passa al.... */
	    currentPtr = currentPtr->nextPtr; /* .... prossimo nodo */

	    }

	    if (previousPtr == NULL) {
	        newPtr->nextPtr = *sPtr;
		*sPtr = newPtr;
	    }
	    else {
	       previousPtr->nextPtr = newPtr;
	       newPtr->nextPtr = currentPtr;
	    }
      }
      else
         printf("%c Non inserito. memoria non disponibile.\n", value);
}

/* Elimina un elemento della lista */
char delete(LISTNODEPTR *sPtr, char value)
{
  LISTNODEPTR previousPtr, currentPtr, tempPtr;

  if (value == (*sPtr)->data) {
     tempPtr = *sPtr;
     *sPtr = (*sPtr)->nextPtr;  /* "sfila il nodo */
     free(tempPtr);    /* libera la memoria usata dal nodo "sfilato" */
     return value;
  }
  else {
      previousPtr = *sPtr;
      currentPtr = (*sPtr)->nextPtr;

      while (currentPtr != NULL && currentPtr->data != value) {
      previousPtr = currentPtr;                             /* passa al ......*/
      currentPtr = currentPtr->nextPtr;                     /* ..... prossimo nodo */
      }

      if (currentPtr != NULL) {
          tempPtr = currentPtr;
	  previousPtr->nextPtr = currentPtr->nextPtr;
	  free(tempPtr);
	  return value;
      }
   }

   return '\0';
 }

 /* Se la lista  vuota, restituisce 1 altrimenti 0 */
 int isEmpty(LISTNODEPTR sPtr)
 {
     return sPtr == NULL;
 }
 /* Visualizza la lista */
void printList(LISTNODEPTR currentPtr)
{
  if (currentPtr == NULL)
      printf("Lista  vuota.\n");
  else {
    printf("la lista :\n\n");

    while (currentPtr != NULL) {
       printf("%c--> ", currentPtr->data);
       currentPtr = currentPtr ->nextPtr;
    }

    printf("NULL \n\n");
 }
}
