/* programma per una pila dinamica */
#include <stdio.h>
#include <stdlib.h>

struct stackNode { /* struttura ricorsiva */
    int data;
    struct stackNode *nextPtr;
};

typedef struct stackNode STACKNODE;
typedef STACKNODE *STACKNODEPTR;

void push(STACKNODEPTR *, int);
int pop(STACKNODEPTR *);
int isEmpty(STACKNODEPTR);
void printStack(STACKNODEPTR);
void instructions(void);

main()
{
   STACKNODEPTR  stackPtr = NULL;  /* punta alla testa della pila */
   int choice, value;

   instructions();
   printf("? ");
   scanf("%d", &choice);

   while (choice != 3) {
   switch (choice) {
       case 1:                       /* aggiunge un valore in cima alla pila */
           printf("Inserisci un valore: ");
	   scanf("%d", &value);
	   push(&stackPtr, value);
	   printStack(stackPtr);
	   break;
        case 2:        /* estrae un valore dalla pila */
           if (!isEmpty(stackPtr))
	      printf("Il valore estratto  %d.\n", pop (&stackPtr));

	   printStack(stackPtr);
	   break;
        default:
	   printf("scelta sbagliata.\n\n");
	   instructions();
	   break;
   }

   printf("? ");
   scanf("%d", &choice);
 }

 printf("Fine della procedura.\n");
 return 0;
}

/* Visualizza le istruzioni */
void instructions(void)
{
   printf("Digita:\n"
          "1 per aggiungere un valore nella pila\n"
	  "2 per estrarre un valore nella pila\n"
	  "3 per terminare la procedura\n");
}

/* Inserisce un nodo in cima alla pila */
void push(STACKNODEPTR *topPtr, int info)
{
   STACKNODEPTR newPtr;

   newPtr = malloc(sizeof(STACKNODE));
   if (newPtr != NULL) {
       newPtr->data = info;
       newPtr->nextPtr = *topPtr;
       *topPtr = newPtr;
   }
   else
          printf("%d Non inserito.Memoria non disponibile.\n", info);
}

/* Rimuove un nodo dalla cima della pila */
int pop(STACKNODEPTR *topPtr)
{
    STACKNODEPTR tempPtr;
    int popValue;

    tempPtr = *topPtr;
    popValue = (*topPtr)->data;
    *topPtr = (*topPtr)->nextPtr;
    free(tempPtr);
    return popValue;
}

/* Visualizza la pila */

void printStack(STACKNODEPTR currentPtr)
{
    if (currentPtr == NULL)
       printf("La pila  vuota.\n\n");
    else {
       printf("La pila :\n");

       while (currentPtr != NULL) {
           printf("%d --> ", currentPtr->data);
	   currentPtr = currentPtr->nextPtr;
       }

       printf("NULL\n\n");
    }
}

/* la pila  vuota? */
int isEmpty(STACKNODEPTR topPtr)
{
   return topPtr == NULL;
}
